TeeInputStream (Bouncy Castle Library 1.85 API Specification)
Date: 2026-07-12

org.bouncycastle.util.io

## Class TeeInputStream

- java.lang.Object
- - java.io.InputStream
  - - org.bouncycastle.util.io.TeeInputStream

- All Implemented Interfaces:
    java.io.Closeable, java.lang.AutoCloseable

      public class TeeInputStream
      extends java.io.InputStream

  An input stream which copies anything read through it to another stream.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `TeeInputStream(java.io.InputStream input, java.io.OutputStream output)` Base constructor.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `available()`
    `void` | `close()`
    `java.io.OutputStream` | `getOutputStream()`
    `int` | `read()`
    `int` | `read(byte[] buf)`
    `int` | `read(byte[] buf, int off, int len)`

    - ### Methods inherited from class java.io.InputStream

      `mark, markSupported, reset, skip`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### TeeInputStream

          public TeeInputStream(java.io.InputStream input,
                                java.io.OutputStream output)

      Base constructor.
      Parameters:
        `input` - input stream to be wrapped.
        `output` - output stream to copy any input read to.

  - ### Method Detail

    - #### available

          public int available()
                        throws java.io.IOException

      Overrides:
        `available` in class `java.io.InputStream`
      Throws:
        `java.io.IOException`

    - #### read

          public int read(byte[] buf)
                   throws java.io.IOException

      Overrides:
        `read` in class `java.io.InputStream`
      Throws:
        `java.io.IOException`

    - #### read

          public int read(byte[] buf,
                          int off,
                          int len)
                   throws java.io.IOException

      Overrides:
        `read` in class `java.io.InputStream`
      Throws:
        `java.io.IOException`

    - #### read

          public int read()
                   throws java.io.IOException

      Specified by:
        `read` in class `java.io.InputStream`
      Throws:
        `java.io.IOException`

    - #### close

          public void close()
                     throws java.io.IOException

      Specified by:
        `close` in interface `java.io.Closeable`
      Specified by:
        `close` in interface `java.lang.AutoCloseable`
      Overrides:
        `close` in class `java.io.InputStream`
      Throws:
        `java.io.IOException`

    - #### getOutputStream

          public java.io.OutputStream getOutputStream()